import java.awt.Color;
import java.awt.geom.Point2D;

/**
 * Eine Clientversion von "Kaesekaestchen".
 * 
 * @author Q11
 * @version 2015-07-08
 */
public class Spiel
{
    private Rechteck [][] querlinie;
    private Rechteck [][] hochlinie;
    private Rechteck [][] kaestchen;
    private int x;
    private int y;

    private Beschriftung eigenName;
    private Beschriftung gegnerName;
    private Ellipse spieleranzeige;
    private Beschriftung endanzeige;

    private Color rot     = new Color (255,   0,   0);
    private Color gelb    = new Color (255, 255,   0);
    private Color grau    = new Color (127, 127, 127);
    private Color weiss   = new Color (255, 255, 255);
    private Color brot    = new Color (185,  92, 121);
    private Color schwarz = new Color (  0,   0,   0);

    private String meinNick;
    private Color meineFarbe;

    private String gegnerNick;
    private Color gegnerFarbe;

    private Beschriftung eigenePunktzahl;
    private Beschriftung gegnerPunktzahl;

    int p;
    int g;

    /**
     * Erstelle ein Spielfeld ... :3 
     */
    public Spiel (int x, int y)
    {
        this.x = x;
        this.y = y;

        int dx = (60 - x)*10;
        int dy = (35 - y)*10;
        ;
        Leinwand.erzeugeLeinwand ("Ksekstchen", 1205, 805, Color.white);

        querlinie = new Rechteck [x][y+1];
        hochlinie = new Rechteck [x+1][y];
        kaestchen = new Rechteck [x+8][y+8];

        for(int i = 0; i < x; i++)
        {
            for(int j = 0; j <= y; j++)
            {
                querlinie[i][j] = new Rechteck();
                querlinie[i][j].setzeBreite(15);
                querlinie[i][j].setzeHoehe(5);
                querlinie[i][j].setzeFarbe(grau);
                querlinie[i][j].setzePosition(20*i+5+dx,20*j+100+dy);

                if (0 == j || y == j)
                {
                    querlinie[i][j].setzeFarbe(schwarz);
                }
            }
        }

        for(int i = 0; i < x; i++)
        {
            for(int j = 0; j <= y; j++)
            {
                kaestchen[i][j] = new Rechteck();
                kaestchen[i][j].setzeBreite(15);
                kaestchen[i][j].setzeHoehe(15);
                kaestchen[i][j].setzeFarbe(weiss);
                kaestchen[i][j].setzePosition(20*i+5+dx,20*j+105+dy);
            }
        }

        for(int i = 0; i <= x; i++)
        {
            for(int j = 0; j < y; j++)
            {
                hochlinie[i][j] = new Rechteck();
                hochlinie[i][j].setzeBreite(5);
                hochlinie[i][j].setzeHoehe(15);
                hochlinie[i][j].setzeFarbe(grau);
                hochlinie[i][j].setzePosition(20*i+dx,20*j+105+dy);

                if (0 == i || x == i)
                {
                    hochlinie[i][j].setzeFarbe(schwarz);
                }
            }
        }

        eigenName = new Beschriftung ();
        eigenName.setzeInhalt ("Nick eingeben ...!");
        eigenName.setzeFarbe (rot);
        eigenName.setzeSchriftgroesse (50);
        eigenName.setzeDrehzentrum (1180, 25);
        eigenName.setzePosition (0, 0);
        eigenName.setzeAusrichtungX (-1);
        eigenName.setzeAusrichtungY (-1);
        eigenName.werdeSichtbar ();

        gegnerName = new Beschriftung ();
        gegnerName.setzeInhalt ("Suche Gegner ...!");
        gegnerName.setzeFarbe (gelb);
        gegnerName.setzeSchriftgroesse (50);
        gegnerName.setzeDrehzentrum (25, 25);
        gegnerName.setzePosition (0, 0);
        gegnerName.setzeAusrichtungX (1);
        gegnerName.setzeAusrichtungY (-1);
        gegnerName.werdeSichtbar ();

        spieleranzeige = new Ellipse();
        spieleranzeige.setzeFarbe(grau);
        spieleranzeige.setzeHoehe (55);
        spieleranzeige.setzeBreite (55);
        spieleranzeige.setzePosition (575, 10);
        spieleranzeige.werdeSichtbar ();

        eigenePunktzahl = new Beschriftung();
        eigenePunktzahl.setzeInhalt ("0");
        eigenePunktzahl.setzeDrehzentrum (655, 37);
        eigenePunktzahl.setzePosition (0, 0);
        eigenePunktzahl.setzeAusrichtungX (1);
        eigenePunktzahl.setzeAusrichtungY (0);
        eigenePunktzahl.setzeSchriftgroesse (30);
        eigenePunktzahl.setzeFarbe (brot);
        eigenePunktzahl.werdeSichtbar ();

        gegnerPunktzahl = new Beschriftung();
        gegnerPunktzahl.setzeInhalt ("0");
        gegnerPunktzahl.setzeDrehzentrum (550, 37);
        gegnerPunktzahl.setzePosition (0, 0);
        gegnerPunktzahl.setzeAusrichtungX (-1);
        gegnerPunktzahl.setzeAusrichtungY (0);
        gegnerPunktzahl.setzeSchriftgroesse (30);
        gegnerPunktzahl.setzeFarbe (brot);
        gegnerPunktzahl.werdeSichtbar ();

        endanzeige = new Beschriftung ();
        endanzeige.setzeInhalt ("");
        endanzeige.setzeDrehzentrum (602, 63);
        endanzeige.setzePosition (0, 0);
        endanzeige.setzeAusrichtungX (0);
        endanzeige.setzeAusrichtungY (-1);
        endanzeige.setzeSchriftgroesse (23);
        endanzeige.setzeFarbe (brot);

        p = 0;
        g = 0;

        Leinwand.gibLeinwand ().erneuere ();
        Chatfenster.gibChatfenster ().aktiviere ();
    }

    /**
     * Fange an.
     */
    public void fangeAn ()
    {
        /*
         * Faerbe das Spielfeld.
         */
        for(int i = 0; i < x; i++)
        {
            for(int j = 0; j <= y; j++)
            {
                querlinie[i][j].setzeFarbe (grau);

                if (0 == j || y == j)
                {
                    querlinie[i][j].setzeFarbe(schwarz);
                }

                querlinie[i][j].werdeSichtbar ();
            }
        }

        for(int i = 0; i < x; i++)
        {
            for(int j = 0; j <= y; j++)
            {
                kaestchen[i][j].setzeFarbe (weiss);
                kaestchen[i][j].werdeSichtbar ();
            }
        }

        for(int i = 0; i <= x; i++)
        {
            for(int j = 0; j < y; j++)
            {
                hochlinie[i][j].setzeFarbe (grau);

                if (0 == i || x == i)
                {
                    hochlinie[i][j].setzeFarbe (schwarz);
                }

                hochlinie[i][j].werdeSichtbar ();
            }
        }

        gegnerPunktzahl.setzeInhalt ("0");
        eigenePunktzahl.setzeInhalt ("0");

        Leinwand.gibLeinwand ().erneuere ();
        Chatfenster.gibChatfenster ().aktiviere ();
    }

    /**
     * Hre auf.
     */
    public void hoereAuf ()
    {
        /*
         * Mache das ganze Spielfeld unsichtbar..
         */
        for(int i = 0; i < x; i++)
        {
            for(int j = 0; j <= y; j++)
            {
                querlinie[i][j].werdeUnsichtbar ();
            }
        }

        for(int i = 0; i < x; i++)
        {
            for(int j = 0; j <= y; j++)
            {
                kaestchen[i][j].werdeUnsichtbar ();
            }
        }

        for(int i = 0; i <= x; i++)
        {
            for(int j = 0; j < y; j++)
            {
                hochlinie[i][j].werdeUnsichtbar ();
            }
        }

        spieleranzeige.setzeFarbe (grau);
        endanzeige.werdeUnsichtbar ();
        
        gegnerName.setzeInhalt ("Suche Gegner ...!");

        gegnerPunktzahl.setzeInhalt ("0");
        eigenePunktzahl.setzeInhalt ("0");

        Leinwand.gibLeinwand ().erneuere ();
        Chatfenster.gibChatfenster ().aktiviere ();
    }

    /**
     * Aendere meinen Namen.
     */
    public void setzeMeinenNamen (String neuerName)
    {
        meinNick = neuerName;

        eigenName.setzeInhalt (neuerName);
        Leinwand.gibLeinwand ().erneuere ();
        Chatfenster.gibChatfenster ().aktiviere ();
    }

    /**
     * Aendere meine Farbe.
     */
    public void setzeMeineFarbe (Color neueFarbe)
    {
        meineFarbe = neueFarbe;

        eigenName.setzeFarbe (neueFarbe);
        Leinwand.gibLeinwand ().erneuere ();
        Chatfenster.gibChatfenster ().aktiviere ();
    }

    /**
     * Aendere den Namen meines Gegners.
     */
    public void setzeGegnerNamen (String neuerName)
    {
        gegnerNick = neuerName;

        gegnerName.setzeInhalt (neuerName);
        Leinwand.gibLeinwand ().erneuere ();
    }

    /**
     * Aendere die Farbe meines Gegners.
     */
    public void setzeGegnerFarbe (Color neueFarbe)
    {
        gegnerFarbe = neueFarbe;

        gegnerName.setzeFarbe (neueFarbe);
        Leinwand.gibLeinwand ().erneuere ();
    }

    /**
     * Nenne die X-Koordinate der angeklickten Querlinie.
     */
    public int gibQuerlinieX(Point2D punkt)
    {
        for(int i = 0; i < x; i++)
        {
            for(int j = 0; j <= y; j++)
            {
                if (querlinie[i][j].enthaelt (punkt))
                {
                    return i;
                }
            }
        }

        return -1;
    }

    /**
     * Nenne die Y-Koordinate der angeklickten Querlinie.
     */
    public int gibQuerlinieY(Point2D punkt)
    {
        for(int i = 0; i < x; i++)
        {
            for(int j = 0; j <= y; j++)
            {
                if (querlinie[i][j].enthaelt (punkt))
                {
                    return j;
                }
            }
        }

        return -1;
    }

    /**
     * Nenne die X-Koordinate der angeklickten Hochlinie.
     */
    public int gibHochlinieX (Point2D punkt)
    {
        for (int i = 0; i <= x; i++)
        {
            for (int j = 0; j < y; j++)
            {
                if (hochlinie[i][j].enthaelt (punkt))
                {
                    return i;
                }
            }
        }

        return -1;
    }

    /**
     * Nenne die Y-Koordinate der angeklickten Hochlinie.
     */
    public int gibHochlinieY (Point2D punkt)
    {
        for (int i = 0; i <= x; i++)
        {
            for (int j = 0; j < y; j++)
            {
                if (hochlinie[i][j].enthaelt (punkt))
                {
                    return j;
                }
            }
        }

        return -1;
    }

    /**
     * Farbe eines Hochbalkens ndern.
     */
    public void faerbeHochbalken (String name, int i, int j)
    {
        if (name.equals (meinNick))
        {
            hochlinie[i][j].setzeFarbe (meineFarbe);
        }
        else
        {
            hochlinie[i][j].setzeFarbe (gegnerFarbe);
        }
    }

    /**
     * Farbe eines Querbalkens ndern.
     */
    public void faerbeQuerbalken (String name, int i, int j)
    {
        if (name.equals (meinNick))
        {
            querlinie[i][j].setzeFarbe (meineFarbe);
        }
        else
        {
            querlinie[i][j].setzeFarbe (gegnerFarbe);
        }
    }

    /**
     * Farbe eines Kstchens ndern.
     */
    public void faerbeKaestchen (String name, int i, int j)
    {
        if (name.equals (meinNick))
        {
            kaestchen[i][j].setzeFarbe (meineFarbe);
            p++;
            eigenePunktzahl.setzeInhalt ("" + p);
        }
        else
        {
            kaestchen[i][j].setzeFarbe (gegnerFarbe);
            g++;
            gegnerPunktzahl.setzeInhalt ("" + g);
        }
    }

    /**
     * Farbe der spieleranzeige ndern.
     * Hier erst wird die Leinwand erneuert; darum mssen die
     * Linien und Kstchen vorher gefrbt werden.
     */
    public void faerbeSpieleranzeige (String name)
    {
        if (name.equals (meinNick))
        {
            spieleranzeige.setzeFarbe (meineFarbe);
            Leinwand.gibLeinwand ().erneuere ();
        }
        else
        {
            spieleranzeige.setzeFarbe (gegnerFarbe);
            Leinwand.gibLeinwand ().erneuere ();
        }
    }

    /**
     * Zeige an, dass ich gewonnen habe.
     */
    public void zeigeGewinnAn ()
    {
        endanzeige.setzeInhalt ("Du hast gewonnen!");
        endanzeige.werdeSichtbar ();
        Leinwand.gibLeinwand ().erneuere ();
        Chatfenster.gibChatfenster ().aktiviere ();
    }

    /**
     * Zeige an, dass ich verloren habe.
     */
    public void zeigeVerlustAn ()
    {
        endanzeige.setzeInhalt ("Du hast verloren ...");
        endanzeige.werdeSichtbar ();
        Leinwand.gibLeinwand ().erneuere ();
        Chatfenster.gibChatfenster ().aktiviere ();
    }

    /** 
     * Zeige an, dass ich unentschieden gespielt habe.
     */
    public void zeigeUnentschiedenAn ()
    {
        endanzeige.setzeInhalt ("Unentschieden.");
        endanzeige.werdeSichtbar ();
        Leinwand.gibLeinwand ().erneuere ();
        Chatfenster.gibChatfenster ().aktiviere ();
    }

    /**
     * Zeige an, dass ich durch Aufgabe gewonnen habe.
     */
    public void zeigeGewinnDurchAufgabeAn ()
    {
        endanzeige.setzeInhalt ("Du hast durch Aufgabe gewonnen!");
        endanzeige.werdeSichtbar ();
        Leinwand.gibLeinwand ().erneuere ();
        Chatfenster.gibChatfenster ().aktiviere ();
    }

    /**
     * Zeige an, dass ich aufgeben habe.
     */
    public void zeigeVerlustDurchAufgabeAn ()
    {
        endanzeige.setzeInhalt ("Du hast aufgegeben ...");
        endanzeige.werdeSichtbar ();
        Leinwand.gibLeinwand ().erneuere ();
        Chatfenster.gibChatfenster ().aktiviere ();
    }
}