import java.io.IOException;
import java.net.Socket;
import java.net.UnknownHostException;

/**
 * Starte einen Spielclient.
 * 
 * @author Q11
 * @version 2015-05-20
 */
public class SpielClient
{
    private Socket meinSocket = null;
    
    /**
     * Konstruktor.
     * Der Konstruktor ist private, da er nicht benutzt werden soll.
     * Verbinde Dich an den angegebenen Port des angegebenen Servers.
     */
    private SpielClient (String serverName, int portNr)
    {
        try 
        {
            meinSocket = new Socket (serverName, portNr);
        } 
        catch (UnknownHostException e) 
        {
            System.err.println ("Finde " + serverName + " nicht.");
        } 
        catch (IOException fehler) 
        {
            System.err.println ("Keine Verbindung zu " + serverName + ".");
        }
    }
    
    /**
     * Nenne meinen Socket.
     */
    public Socket gibSocket ()
    {
        return meinSocket;
    }
    
    /**
     * Starte einen Client. Verbinde Dich dabei an den
     * angegebenen Port des angegebenen Servers.
     */
    public static void starteClient (String serverName, int portNr)
    {
        SpielClient client = new SpielClient (serverName, portNr);
        
        if (client != null)
        {
            Socket clientSocket = client.gibSocket ();
            
            if (clientSocket != null)
            {  
                /*
                 * Starte den ClientEmpfangsProzess in einem neuen Thread,
                 * den ClientSendeProzess jedoch im laufenden Thread, damit er
                 * Zugriff auf die Standardeingabe hat.
                 */
                ClientSendeProzess    clientSender     = new ClientSendeProzess (clientSocket);
                ClientEmpfangsProzess clientEmpfaenger = new ClientEmpfangsProzess (clientSocket, clientSender);
                
                new Thread (clientEmpfaenger).start ();        
                clientSender.run ();
            }
        }
    }
}
